#include <stdlib.h>
#include <string.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
#define YYPREFIX "yy"
#line 25 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
#include <sys/types.h>
#include <sys/queue.h>
#include <sys/tree.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/ioctl.h>

#include <net/if.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <event.h>
#include <ifaddrs.h>
#include <imsg.h>
#include <inttypes.h>
#include <limits.h>
#include <netdb.h>
#include <pwd.h>
#include <resolv.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>
#include <util.h>

#include <openssl/ssl.h>

#include "smtpd.h"
#include "ssl.h"
#include "log.h"

TAILQ_HEAD(files, file)		 files = TAILQ_HEAD_INITIALIZER(files);
static struct file {
	TAILQ_ENTRY(file)	 entry;
	FILE			*stream;
	char			*name;
	size_t			 ungetpos;
	size_t			 ungetsize;
	u_char			*ungetbuf;
	int			 eof_reached;
	int			 lineno;
	int			 errors;
} *file, *topfile;
struct file	*pushfile(const char *, int);
int		 popfile(void);
int		 check_file_secrecy(int, const char *);
int		 yyparse(void);
int		 yylex(void);
int		 kw_cmp(const void *, const void *);
int		 lookup(char *);
int		 igetc(void);
int		 lgetc(int);
void		 lungetc(int);
int		 findeol(void);
int		 yyerror(const char *, ...)
    __attribute__((__format__ (printf, 1, 2)))
    __attribute__((__nonnull__ (1)));

TAILQ_HEAD(symhead, sym)	 symhead = TAILQ_HEAD_INITIALIZER(symhead);
struct sym {
	TAILQ_ENTRY(sym)	 entry;
	int			 used;
	int			 persist;
	char			*nam;
	char			*val;
};
int		 symset(const char *, const char *, int);
char		*symget(const char *);

struct smtpd		*conf = NULL;
static int		 errors = 0;

struct table		*table = NULL;
struct mta_limits	*limits;
static struct pki	*pki;
static struct ca	*sca;

struct dispatcher	*dispatcher;
struct rule		*rule;


enum listen_options {
	LO_FAMILY	= 0x000001,
	LO_PORT		= 0x000002,
	LO_SSL		= 0x000004,
	LO_FILTER      	= 0x000008,
	LO_PKI      	= 0x000010,
	LO_AUTH      	= 0x000020,
	LO_TAG      	= 0x000040,
	LO_HOSTNAME   	= 0x000080,
	LO_HOSTNAMES   	= 0x000100,
	LO_MASKSOURCE  	= 0x000200,
	LO_NODSN	= 0x000400,
	LO_SENDERS	= 0x000800,
	LO_RECEIVEDAUTH = 0x001000,
	LO_MASQUERADE	= 0x002000,
	LO_CA		= 0x010000
};

static struct listen_opts {
	char	       *ifx;
	int		family;
	in_port_t	port;
	uint16_t	ssl;
	char	       *filtername;
	char	       *pki;
	char	       *ca;
	uint16_t       	auth;
	struct table   *authtable;
	char	       *tag;
	char	       *hostname;
	struct table   *hostnametable;
	struct table   *sendertable;
	uint16_t	flags;

	uint32_t       	options;
} listen_opts;

static void	create_sock_listener(struct listen_opts *);
static void	create_if_listener(struct listen_opts *);
static void	config_listener(struct listener *, struct listen_opts *);
static int	host_v4(struct listen_opts *);
static int	host_v6(struct listen_opts *);
static int	host_dns(struct listen_opts *);
static int	interface(struct listen_opts *);

int		 delaytonum(char *);
int		 is_if_in_group(const char *, const char *);

static int config_lo_filter(struct listen_opts *, char *);
static int config_lo_mask_source(struct listen_opts *);

typedef struct {
	union {
		int64_t		 number;
		struct table	*table;
		char		*string;
		struct host	*host;
		struct mailaddr	*maddr;
	} v;
	int lineno;
} YYSTYPE;

#line 161 "parse.c"
#define ACTION 257
#define ALIAS 258
#define ANY 259
#define ARROW 260
#define AUTH 261
#define AUTH_OPTIONAL 262
#define BACKUP 263
#define BOUNCE 264
#define CA 265
#define CERT 266
#define CIPHERS 267
#define COMPRESSION 268
#define DHE 269
#define DOMAIN 270
#define ENCRYPTION 271
#define ERROR 272
#define EXPAND_ONLY 273
#define FILTER 274
#define FOR 275
#define FORWARD_ONLY 276
#define FROM 277
#define HELO 278
#define HELO_SRC 279
#define HOST 280
#define HOSTNAME 281
#define HOSTNAMES 282
#define INCLUDE 283
#define INET4 284
#define INET6 285
#define JUNK 286
#define KEY 287
#define LIMIT 288
#define LISTEN 289
#define LMTP 290
#define LOCAL 291
#define MAIL_FROM 292
#define MAILDIR 293
#define MASK_SRC 294
#define MASQUERADE 295
#define MATCH 296
#define MAX_MESSAGE_SIZE 297
#define MAX_DEFERRED 298
#define MBOX 299
#define MDA 300
#define MTA 301
#define MX 302
#define NO_DSN 303
#define NO_VERIFY 304
#define ON 305
#define PKI 306
#define PORT 307
#define QUEUE 308
#define RCPT_TO 309
#define RECIPIENT 310
#define RECEIVEDAUTH 311
#define RELAY 312
#define REJECT 313
#define SCHEDULER 314
#define SENDER 315
#define SENDERS 316
#define SMTP 317
#define SMTPS 318
#define SOCKET 319
#define SRC 320
#define SUB_ADDR_DELIM 321
#define TABLE 322
#define TAG 323
#define TAGGED 324
#define TLS 325
#define TLS_REQUIRE 326
#define TO 327
#define TTL 328
#define USER 329
#define USERBASE 330
#define VERIFY 331
#define VIRTUAL 332
#define WARN_INTERVAL 333
#define WRAPPER 334
#define STRING 335
#define NUMBER 336
#define YYERRCODE 256
const short yylhs[] =
	{                                        -1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    7,    8,   20,
   20,   20,   22,   22,   21,    3,    3,   23,   23,   24,
   25,   25,   26,   27,   27,   28,   28,   30,    9,   32,
   10,   33,   31,   11,   11,   12,   36,   12,   37,   12,
   39,   13,   40,   40,   40,   38,   38,   14,   14,   14,
   14,   15,   16,   16,   16,   16,   43,   43,   43,   43,
   43,   44,   44,   46,   45,   47,   45,   48,   45,   49,
   45,   50,   45,   51,   45,   52,   45,   53,   45,   54,
   45,   55,   45,   56,   56,   56,   56,   56,   56,   56,
   56,   56,   56,   56,   56,   57,   57,   58,   59,   59,
   60,   61,   61,   62,   18,   63,   63,   63,   63,   63,
   63,   63,   63,   63,   63,   63,   63,   63,   63,   64,
   64,   65,   66,   66,   67,   19,    2,    2,   68,   29,
   29,   69,   42,   42,   70,   34,   34,   71,   71,   71,
   35,   35,   72,   41,   41,   73,   73,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   75,   75,   76,   77,   78,   78,   79,   79,   80,
   17,    1,   81,    1,    5,   82,    5,    6,    4,    4,
};
const short yylen[] =
	{                                         2,
    0,    2,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    2,    3,    1,
    1,    0,    2,    0,    2,    1,    0,    1,    1,    3,
    1,    3,    1,    1,    3,    1,    1,    0,    4,    0,
    4,    2,    1,    3,    4,    3,    0,    7,    0,    4,
    0,    4,    2,    2,    2,    2,    0,    2,    2,    3,
    3,    3,    3,    3,    3,    3,    2,    2,    2,    2,
    2,    2,    0,    0,    3,    0,    3,    0,    4,    0,
    4,    0,    5,    0,    4,    0,    5,    0,    4,    0,
    3,    0,    3,    2,    2,    2,    2,    2,    2,    3,
    1,    2,    1,    2,    2,    2,    0,    2,    1,    1,
    2,    2,    0,    0,    5,    3,    3,    2,    2,    3,
    3,    3,    3,    3,    3,    4,    3,    3,    4,    2,
    0,    1,    1,    2,    0,    4,    1,    1,    1,    3,
    1,    2,    2,    0,    2,    2,    0,    1,    1,    2,
    2,    0,    2,    2,    0,    2,    1,    1,    1,    2,
    2,    2,    1,    2,    1,    1,    2,    2,    2,    1,
    1,    2,    2,    2,    2,    2,    1,    1,    1,    2,
    3,    1,    1,    2,    2,    2,    0,    2,    0,    0,
    4,    3,    0,    6,    1,    0,    4,    3,    1,    1,
};
const short yydefred[] =
	{                                      1,
    0,    0,    0,    0,    0,    0,  190,  135,    0,    0,
    0,    0,    0,    0,    0,    0,    2,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   17,  114,   38,   40,   18,    0,    0,    0,    0,
    0,    0,   51,   58,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   14,    3,    4,    5,    6,    7,    8,
    9,   10,   11,   12,   13,   15,   16,    0,    0,    0,
    0,   26,    0,    0,    0,    0,   44,    0,    0,    0,
    0,   46,    0,   60,   61,    0,   62,    0,   64,    0,
   63,    0,  138,  137,   65,   66,  192,    0,   19,   92,
   90,    0,    0,   74,    0,    0,  109,  110,    0,  139,
    0,  141,    0,   41,   43,    0,    0,  191,  182,  183,
    0,    0,    0,    0,    0,    0,    0,  118,  130,    0,
  133,  136,  142,  146,   45,    0,  148,  149,    0,   50,
    0,    0,    0,    0,   52,    0,  153,  154,  145,  143,
    0,    0,    0,    0,   78,    0,    0,    0,   88,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  108,    0,    0,  115,    0,   42,    0,  157,    0,  184,
    0,    0,    0,    0,    0,    0,  158,  159,  177,  179,
    0,    0,  178,    0,    0,    0,  165,    0,    0,  185,
  195,  196,    0,  120,  199,  200,  128,    0,  127,  125,
  124,  123,    0,  117,  121,  122,  116,  132,  134,   47,
  150,  151,   53,   55,   54,   56,    0,    0,   37,    0,
   36,    0,    0,    0,    0,    0,    0,    0,   93,   91,
   86,    0,    0,   82,    0,   77,   75,    0,  105,    0,
   97,   94,   95,  102,   99,   96,   98,  104,  106,  111,
  112,  140,  156,  186,  172,  173,  169,  162,  175,  176,
  168,  160,  161,    0,  164,  174,  167,  188,    0,    0,
  129,  126,    0,   29,   28,    0,    0,   20,    0,   21,
    0,  194,   68,   67,   70,   69,   71,   72,    0,   85,
   79,    0,   81,   89,  100,  181,    0,  198,   48,   30,
    0,   25,    0,   32,   33,   35,   87,   83,  197,   23,
};
const short yydgoto[] =
	{                                       1,
   18,   95,   73,  204,  205,  206,   19,   20,   21,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,  289,
  290,  312,  286,  228,  229,  230,  231,  232,  111,   69,
  114,   70,  115,   77,  140,  283,   81,  145,   83,  146,
   87,   91,  238,  239,  107,  158,  157,  243,  245,  302,
  242,  299,  248,  153,  152,  170,  171,  108,  109,  173,
  174,   68,   74,   75,  219,  132,   38,  112,   78,   92,
  141,   88,  179,  199,  118,  119,  120,  180,  200,   37,
   98,  279,
};
const short yysindex[] =
	{                                      0,
  -10,   17, -283, -280, -279, -278,    0,    0, -259, -257,
 -270, -243, -209, -230, -253,   29,    0,   82,   83,   84,
   86,   87,   94,  100,  102,  103,  104,  105,  110,  113,
  114,    0,    0,    0,    0,    0, -178,  106, -200, -198,
 -135, -195,    0,    0, -188, -185, -183, -182, -181, -290,
 -174, -172, -170,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -157, -169, -122,
 -281,    0, -245,  106, -244, -179,    0, -200, -166,  -98,
 -261,    0, -226,    0,    0, -163,    0, -183,    0, -162,
    0, -181,    0,    0,    0,    0,    0,   53,    0,    0,
    0, -154, -252,    0, -152, -101,    0,    0, -144,    0,
  141,    0, -149,    0,    0, -232, -136,    0,    0,    0,
  -55, -220, -247,  -55,  -55,  -55,  -55,    0,    0, -147,
    0,    0,    0,    0,    0, -142,    0,    0, -141,    0,
 -261, -138, -137, -134,    0, -226,    0,    0,    0,    0,
 -133, -223, -223, -117,    0,  -92, -223, -223,    0,  -55,
 -103, -131, -129,  -55,  -55, -127, -126,  -55, -104, -101,
    0, -125, -144,    0, -169,    0, -124,    0, -232,    0,
  -55,  -55, -123, -121, -120,  -55,    0,    0,    0,    0,
 -115, -287,    0,  -55, -128, -114,    0, -113, -136,    0,
    0,    0, -112,    0,    0,    0,    0,  -55,    0,    0,
    0,    0,  -55,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -53,    7,    0,    7,
    0,   97,  -55, -110,  -55,  -55, -109, -223,    0,    0,
    0, -223, -223,    0, -223,    0,    0, -223,    0, -108,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -82,    0,    0,    0,    0, -133,  166,
    0,    0, -261,    0,    0, -106,  220,    0, -102,    0,
 -100,    0,    0,    0,    0,    0,    0,    0, -223,    0,
    0, -223,    0,    0,    0,    0,  107,    0,    0,    0,
  220,    0,  -53,    0,    0,    0,    0,    0,    0,    0,};
const short yyrindex[] =
	{                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -191,  221,    0,
   -9,    0,    0,    0,   94,    0,  224,    0,  226,    0,
    0,  115,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -191,    0,    0,    0,  221,    0,    0,
  227,    0,   86,    0,    0,    0,    0,  224,    0,    0,
    0,  226,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    1,    0,    0,   -7,    0,    0,  229,    0,
  230,    0,    0,    0,    0,  231,  232,    0,    0,    0,
  314,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  227,    0,    0,    0,    0,   86,    0,    0,    0,    0,
    0,   -6,   -6,    8,    0,   16,   -6,   -6,    0,    0,
   78,    0,    0,    0,    0,    0,    0,    0,   88,   -7,
    0,    0,  229,    0,    0,    0,    0,    0,  231,    0,
  111,  158,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  186,    0,    0,  233,  232,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   -8, -119,    0, -118,
    0,    0,    0,    0,    0,    0,    0,   -6,    0,    0,
    0,   -6,   -6,    0,   -6,    0,    0,   -6,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  261,    0,    0,    0,    0,    0,    0,
    0,    0,  227,    0,    0,    0,  -91,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   -6,    0,
    0,   -6,    0,    0,    0,    0,    0,    0,    0,    0,
  -91,    0,    0,    0,    0,    0,    0,    0,    0,    0,};
const short yygindex[] =
	{                                      0,
    0,    0,    0, -105,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   15,
    0,  -63,    0,    0,  -40,    0,  -41,  -28,    0,    0,
    0,    0,    0,  174, -132,    0,    0,  112,    0,    0,
  165,  164,    0, -143,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   90,    0,    0,    0,
   89,    0,    0,  183,    0,    0,    0,   92,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   85,   62,    0,
    0,    0,
};
#define YYTABLESIZE 639
const short yytable[] =
	{                                      17,
   49,   33,  107,   73,  203,   31,   34,  285,  222,  240,
   76,  210,  130,  246,  247,  121,  287,   84,  214,  215,
  216,  217,  137,  138,   44,   80,   32,   45,   39,  122,
   41,  123,  124,  155,  233,   33,   48,  116,  207,  142,
   42,  177,  143,  211,   93,   94,  125,  272,  273,  208,
  288,   33,   34,  117,  249,   35,   36,   49,  253,  254,
  144,  178,  257,  126,   43,  131,   50,  202,  131,   27,
  209,  212,  213,  139,   40,  265,  266,  127,   47,  128,
  270,   52,  156,   27,   46,   27,   27,  101,  274,   53,
   51,   54,   55,   56,  298,   57,   58,  103,  300,  301,
   27,  303,  281,   59,  304,  234,  235,  282,  236,   60,
  237,   61,   62,   63,   64,  100,   33,   27,  101,   65,
  170,  131,   66,   67,  181,  182,   71,  293,  183,  295,
  296,   27,  102,   27,   76,  103,   79,  184,   72,   80,
   82,  104,  105,  113,  185,  186,   84,  187,  188,   85,
  309,   86,   89,   90,  106,  317,  133,  189,  318,  160,
   96,  161,   97,  162,   99,  110,  190,  171,  135,  191,
  192,  136,  147,  149,  193,  151,  163,  164,  165,  194,
  154,  195,  159,  172,  175,  176,  196,  218,  197,  198,
  166,  241,  220,  244,  221,  163,  223,  224,  250,  258,
  225,  227,  275,  251,  167,  252,  284,  255,  256,  260,
  263,  267,  306,  268,  269,   22,   22,  277,  168,  271,
  276,  292,  280,  169,  294,  297,  305,  308,  310,  311,
  147,  319,  313,  155,  315,  144,  152,  193,  113,   39,
  187,  189,  166,   24,  291,    2,    3,  320,  314,  316,
  307,  134,  148,    4,    5,  150,  129,  226,   76,  259,
  278,  261,    0,  264,    0,   84,  262,    0,    0,    0,
  180,    0,    6,   80,   49,   49,    0,    0,    7,  201,
    0,    0,    0,    0,    0,    8,    0,    0,    0,    9,
   10,    0,    0,    0,    0,   11,    0,   12,    0,    0,
    0,    0,    0,   13,    0,    0,   14,    0,    0,    0,
    0,   15,    0,    0,    0,    0,    0,    0,    0,    0,
  107,   73,    0,    0,   16,   49,   33,    0,   76,   76,
   76,    0,   76,    0,   76,   84,   84,   84,  101,   84,
  101,   84,  101,   80,   80,   80,  119,   80,  103,   80,
  103,    0,  103,    0,    0,  101,  101,  101,    0,    0,
    0,    0,    0,    0,    0,  103,  103,  103,    0,  101,
    0,  170,  170,    0,    0,  170,    0,    0,    0,  103,
    0,    0,    0,  101,  170,    0,    0,    0,    0,    0,
    0,  170,  170,  103,  170,  170,    0,  101,    0,    0,
    0,    0,  101,    0,  170,  101,    0,  103,    0,    0,
    0,    0,  103,  170,    0,  103,  170,  170,  171,  171,
    0,  170,  171,    0,    0,    0,  170,    0,  170,    0,
    0,  171,    0,  170,    0,  170,  170,    0,  171,  171,
    0,  171,  171,    0,    0,    0,  163,  163,    0,    0,
  163,  171,    0,    0,    0,    0,    0,    0,    0,  163,
  171,    0,    0,  171,  171,    0,  163,  163,  171,  163,
  163,    0,    0,  171,    0,  171,    0,    0,    0,  163,
  171,    0,  171,  171,    0,    0,    0,    0,  163,    0,
    0,  163,  163,  166,  166,    0,  163,  166,    0,    0,
    0,  163,    0,  163,    0,    0,  166,    0,  163,    0,
  163,  163,    0,  166,  166,    0,  166,  166,    0,    0,
    0,  180,  180,    0,    0,  180,  166,    0,    0,    0,
    0,    0,    0,    0,  180,  166,    0,    0,  166,  166,
    0,  180,  180,  166,  180,  180,    0,    0,  166,    0,
  166,    0,    0,    0,  180,  166,    0,  166,  166,    0,
    0,    0,    0,  180,    0,    0,  180,  180,    0,    0,
  119,  180,    0,    0,  119,    0,  180,    0,  180,    0,
    0,    0,    0,  180,    0,  180,  180,    0,  119,    0,
  119,  119,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  119,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  119,    0,    0,    0,  119,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  119,    0,  119,
};
const short yycheck[] =
	{                                      10,
   10,   10,   10,   10,   60,  125,  125,   61,  141,  153,
   10,  259,  257,  157,  158,  261,   10,   10,  124,  125,
  126,  127,  284,  285,  268,   10,   10,  271,  288,  275,
  288,  277,  278,  286,  258,   44,  267,  319,  259,  266,
  298,  274,  269,  291,  335,  336,  292,  335,  336,  270,
   44,  335,  333,  335,  160,  335,  335,  288,  164,  165,
  287,  294,  168,  309,  335,  257,  297,  123,  313,  261,
  291,  319,  320,  335,  334,  181,  182,  323,  288,  325,
  186,  335,  335,  275,  328,  277,  278,   10,  194,   61,
  321,   10,   10,   10,  238,   10,   10,   10,  242,  243,
  292,  245,  208,   10,  248,  329,  330,  213,  332,   10,
  334,   10,   10,   10,   10,  273,  125,  309,  276,   10,
   10,  313,   10,   10,  261,  262,  305,  233,  265,  235,
  236,  323,  290,  325,  335,  293,  335,  274,   33,  275,
  336,  299,  300,  266,  281,  282,  335,  284,  285,  335,
  283,  335,  335,  335,  312,  299,  336,  294,  302,  261,
  335,  263,  335,  265,  335,  335,  303,   10,  335,  306,
  307,  270,  336,  336,  311,  123,  278,  279,  280,  316,
  335,  318,  335,  328,   44,  335,  323,  335,  325,  326,
  292,  309,  335,  286,  336,   10,  335,  335,  302,  304,
  335,  335,  331,  335,  306,  335,  260,  335,  335,  335,
  335,  335,  295,  335,  335,  335,  335,  331,  320,  335,
  335,  125,  335,  325,  335,  335,  335,   62,  335,   10,
   10,  125,  335,   10,  335,   10,   10,  123,   10,   10,
   10,   10,   10,  335,  230,  256,  257,  311,  289,  291,
  279,   78,   88,  264,  265,   92,   74,  146,  258,  170,
  199,  173,   -1,  179,   -1,  258,  175,   -1,   -1,   -1,
   10,   -1,  283,  258,  284,  285,   -1,   -1,  289,  335,
   -1,   -1,   -1,   -1,   -1,  296,   -1,   -1,   -1,  300,
  301,   -1,   -1,   -1,   -1,  306,   -1,  308,   -1,   -1,
   -1,   -1,   -1,  314,   -1,   -1,  317,   -1,   -1,   -1,
   -1,  322,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  328,  328,   -1,   -1,  335,  335,  335,   -1,  328,  329,
  330,   -1,  332,   -1,  334,  328,  329,  330,  261,  332,
  263,  334,  265,  328,  329,  330,   33,  332,  261,  334,
  263,   -1,  265,   -1,   -1,  278,  279,  280,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  278,  279,  280,   -1,  292,
   -1,  261,  262,   -1,   -1,  265,   -1,   -1,   -1,  292,
   -1,   -1,   -1,  306,  274,   -1,   -1,   -1,   -1,   -1,
   -1,  281,  282,  306,  284,  285,   -1,  320,   -1,   -1,
   -1,   -1,  325,   -1,  294,  328,   -1,  320,   -1,   -1,
   -1,   -1,  325,  303,   -1,  328,  306,  307,  261,  262,
   -1,  311,  265,   -1,   -1,   -1,  316,   -1,  318,   -1,
   -1,  274,   -1,  323,   -1,  325,  326,   -1,  281,  282,
   -1,  284,  285,   -1,   -1,   -1,  261,  262,   -1,   -1,
  265,  294,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,
  303,   -1,   -1,  306,  307,   -1,  281,  282,  311,  284,
  285,   -1,   -1,  316,   -1,  318,   -1,   -1,   -1,  294,
  323,   -1,  325,  326,   -1,   -1,   -1,   -1,  303,   -1,
   -1,  306,  307,  261,  262,   -1,  311,  265,   -1,   -1,
   -1,  316,   -1,  318,   -1,   -1,  274,   -1,  323,   -1,
  325,  326,   -1,  281,  282,   -1,  284,  285,   -1,   -1,
   -1,  261,  262,   -1,   -1,  265,  294,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  274,  303,   -1,   -1,  306,  307,
   -1,  281,  282,  311,  284,  285,   -1,   -1,  316,   -1,
  318,   -1,   -1,   -1,  294,  323,   -1,  325,  326,   -1,
   -1,   -1,   -1,  303,   -1,   -1,  306,  307,   -1,   -1,
  257,  311,   -1,   -1,  261,   -1,  316,   -1,  318,   -1,
   -1,   -1,   -1,  323,   -1,  325,  326,   -1,  275,   -1,
  277,  278,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  292,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  309,   -1,   -1,   -1,  313,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  323,   -1,  325,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 336
#if YYDEBUG
const char * const yyname[] =
	{
"end-of-file",0,0,0,0,0,0,0,0,0,"'\\n'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,"'!'",0,0,0,0,0,0,0,0,0,0,"','",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'<'","'='",
"'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,"ACTION","ALIAS","ANY","ARROW","AUTH","AUTH_OPTIONAL","BACKUP","BOUNCE","CA",
"CERT","CIPHERS","COMPRESSION","DHE","DOMAIN","ENCRYPTION","ERROR",
"EXPAND_ONLY","FILTER","FOR","FORWARD_ONLY","FROM","HELO","HELO_SRC","HOST",
"HOSTNAME","HOSTNAMES","INCLUDE","INET4","INET6","JUNK","KEY","LIMIT","LISTEN",
"LMTP","LOCAL","MAIL_FROM","MAILDIR","MASK_SRC","MASQUERADE","MATCH",
"MAX_MESSAGE_SIZE","MAX_DEFERRED","MBOX","MDA","MTA","MX","NO_DSN","NO_VERIFY",
"ON","PKI","PORT","QUEUE","RCPT_TO","RECIPIENT","RECEIVEDAUTH","RELAY","REJECT",
"SCHEDULER","SENDER","SENDERS","SMTP","SMTPS","SOCKET","SRC","SUB_ADDR_DELIM",
"TABLE","TAG","TAGGED","TLS","TLS_REQUIRE","TO","TTL","USER","USERBASE",
"VERIFY","VIRTUAL","WARN_INTERVAL","WRAPPER","STRING","NUMBER",
};
const char * const yyrule[] =
	{"$accept : grammar",
"grammar :",
"grammar : grammar '\\n'",
"grammar : grammar include '\\n'",
"grammar : grammar varset '\\n'",
"grammar : grammar bounce '\\n'",
"grammar : grammar ca '\\n'",
"grammar : grammar mda '\\n'",
"grammar : grammar mta '\\n'",
"grammar : grammar pki '\\n'",
"grammar : grammar queue '\\n'",
"grammar : grammar scheduler '\\n'",
"grammar : grammar smtp '\\n'",
"grammar : grammar listen '\\n'",
"grammar : grammar table '\\n'",
"grammar : grammar dispatcher '\\n'",
"grammar : grammar match '\\n'",
"grammar : grammar error '\\n'",
"include : INCLUDE STRING",
"varset : STRING '=' STRING",
"comma : ','",
"comma : nl",
"comma :",
"optnl : '\\n' optnl",
"optnl :",
"nl : '\\n' optnl",
"negation : '!'",
"negation :",
"assign : '='",
"assign : ARROW",
"keyval : STRING assign STRING",
"keyval_list : keyval",
"keyval_list : keyval comma keyval_list",
"stringel : STRING",
"string_list : stringel",
"string_list : stringel comma string_list",
"tableval_list : string_list",
"tableval_list : keyval_list",
"$$1 :",
"bounce : BOUNCE WARN_INTERVAL $$1 bouncedelays",
"$$2 :",
"ca : CA STRING $$2 ca_params",
"ca_params_opt : CERT STRING",
"ca_params : ca_params_opt",
"mda : MDA LIMIT limits_mda",
"mda : MDA WRAPPER STRING STRING",
"mta : MTA MAX_DEFERRED NUMBER",
"$$3 :",
"mta : MTA LIMIT FOR DOMAIN STRING $$3 limits_mta",
"$$4 :",
"mta : MTA LIMIT $$4 limits_mta",
"$$5 :",
"pki : PKI STRING $$5 pki_params",
"pki_params_opt : CERT STRING",
"pki_params_opt : KEY STRING",
"pki_params_opt : DHE STRING",
"pki_params : pki_params_opt pki_params",
"pki_params :",
"queue : QUEUE COMPRESSION",
"queue : QUEUE ENCRYPTION",
"queue : QUEUE ENCRYPTION STRING",
"queue : QUEUE TTL STRING",
"scheduler : SCHEDULER LIMIT limits_scheduler",
"smtp : SMTP LIMIT limits_smtp",
"smtp : SMTP CIPHERS STRING",
"smtp : SMTP MAX_MESSAGE_SIZE size",
"smtp : SMTP SUB_ADDR_DELIM STRING",
"dispatcher_local_option : USER STRING",
"dispatcher_local_option : ALIAS tables",
"dispatcher_local_option : VIRTUAL tables",
"dispatcher_local_option : USERBASE tables",
"dispatcher_local_option : WRAPPER STRING",
"dispatcher_local_options : dispatcher_local_option dispatcher_local_options",
"dispatcher_local_options :",
"$$6 :",
"dispatcher_local : MBOX $$6 dispatcher_local_options",
"$$7 :",
"dispatcher_local : MAILDIR $$7 dispatcher_local_options",
"$$8 :",
"dispatcher_local : MAILDIR JUNK $$8 dispatcher_local_options",
"$$9 :",
"dispatcher_local : MAILDIR STRING $$9 dispatcher_local_options",
"$$10 :",
"dispatcher_local : MAILDIR STRING JUNK $$10 dispatcher_local_options",
"$$11 :",
"dispatcher_local : LMTP STRING $$11 dispatcher_local_options",
"$$12 :",
"dispatcher_local : LMTP STRING RCPT_TO $$12 dispatcher_local_options",
"$$13 :",
"dispatcher_local : MDA STRING $$13 dispatcher_local_options",
"$$14 :",
"dispatcher_local : FORWARD_ONLY $$14 dispatcher_local_options",
"$$15 :",
"dispatcher_local : EXPAND_ONLY $$15 dispatcher_local_options",
"dispatcher_remote_option : HELO STRING",
"dispatcher_remote_option : HELO_SRC tables",
"dispatcher_remote_option : PKI STRING",
"dispatcher_remote_option : CA STRING",
"dispatcher_remote_option : SRC tables",
"dispatcher_remote_option : MAIL_FROM STRING",
"dispatcher_remote_option : BACKUP MX STRING",
"dispatcher_remote_option : BACKUP",
"dispatcher_remote_option : HOST tables",
"dispatcher_remote_option : TLS",
"dispatcher_remote_option : TLS NO_VERIFY",
"dispatcher_remote_option : AUTH tables",
"dispatcher_remote_options : dispatcher_remote_option dispatcher_remote_options",
"dispatcher_remote_options :",
"dispatcher_remote : RELAY dispatcher_remote_options",
"dispatcher_type : dispatcher_local",
"dispatcher_type : dispatcher_remote",
"dispatcher_option : TTL STRING",
"dispatcher_options : dispatcher_option dispatcher_options",
"dispatcher_options :",
"$$16 :",
"dispatcher : ACTION STRING $$16 dispatcher_type dispatcher_options",
"match_option : negation TAG tables",
"match_option : negation HELO tables",
"match_option : negation TLS",
"match_option : negation AUTH",
"match_option : negation AUTH tables",
"match_option : negation MAIL_FROM tables",
"match_option : negation RCPT_TO tables",
"match_option : negation FROM SOCKET",
"match_option : negation FROM LOCAL",
"match_option : negation FROM ANY",
"match_option : negation FROM SRC tables",
"match_option : negation FOR LOCAL",
"match_option : negation FOR ANY",
"match_option : negation FOR DOMAIN tables",
"match_options : match_option match_options",
"match_options :",
"match_dispatcher : STRING",
"action : REJECT",
"action : ACTION match_dispatcher",
"$$17 :",
"match : MATCH $$17 match_options action",
"size : NUMBER",
"size : STRING",
"bouncedelay : STRING",
"bouncedelays : bouncedelays ',' bouncedelay",
"bouncedelays : bouncedelay",
"opt_limit_mda : STRING NUMBER",
"limits_smtp : opt_limit_smtp limits_smtp",
"limits_smtp :",
"opt_limit_smtp : STRING NUMBER",
"limits_mda : opt_limit_mda limits_mda",
"limits_mda :",
"opt_limit_mta : INET4",
"opt_limit_mta : INET6",
"opt_limit_mta : STRING NUMBER",
"limits_mta : opt_limit_mta limits_mta",
"limits_mta :",
"opt_limit_scheduler : STRING NUMBER",
"limits_scheduler : opt_limit_scheduler limits_scheduler",
"limits_scheduler :",
"opt_sock_listen : FILTER STRING",
"opt_sock_listen : MASK_SRC",
"opt_if_listen : INET4",
"opt_if_listen : INET6",
"opt_if_listen : PORT STRING",
"opt_if_listen : PORT NUMBER",
"opt_if_listen : FILTER STRING",
"opt_if_listen : SMTPS",
"opt_if_listen : SMTPS VERIFY",
"opt_if_listen : TLS",
"opt_if_listen : TLS_REQUIRE",
"opt_if_listen : TLS_REQUIRE VERIFY",
"opt_if_listen : PKI STRING",
"opt_if_listen : CA STRING",
"opt_if_listen : AUTH",
"opt_if_listen : AUTH_OPTIONAL",
"opt_if_listen : AUTH tables",
"opt_if_listen : AUTH_OPTIONAL tables",
"opt_if_listen : TAG STRING",
"opt_if_listen : HOSTNAME STRING",
"opt_if_listen : HOSTNAMES tables",
"opt_if_listen : MASK_SRC",
"opt_if_listen : RECEIVEDAUTH",
"opt_if_listen : NO_DSN",
"opt_if_listen : SENDERS tables",
"opt_if_listen : SENDERS tables MASQUERADE",
"listener_type : socket_listener",
"listener_type : if_listener",
"socket_listener : SOCKET sock_listen",
"if_listener : STRING if_listen",
"sock_listen : opt_sock_listen sock_listen",
"sock_listen :",
"if_listen : opt_if_listen if_listen",
"if_listen :",
"$$18 :",
"listen : LISTEN $$18 ON listener_type",
"table : TABLE STRING STRING",
"$$19 :",
"table : TABLE STRING $$19 '{' tableval_list '}'",
"tablenew : STRING",
"$$20 :",
"tablenew : '{' $$20 tableval_list '}'",
"tableref : '<' STRING '>'",
"tables : tablenew",
"tables : tableref",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
/* LINTUSED */
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
unsigned int yystacksize;
int yyparse(void);
#line 1568 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"

struct keywords {
	const char	*k_name;
	int		 k_val;
};

int
yyerror(const char *fmt, ...)
{
	va_list		 ap;
	char		*msg;

	file->errors++;
	va_start(ap, fmt);
	if (vasprintf(&msg, fmt, ap) == -1)
		fatalx("yyerror vasprintf");
	va_end(ap);
	logit(LOG_CRIT, "%s:%d: %s", file->name, yylval.lineno, msg);
	free(msg);
	return (0);
}

int
kw_cmp(const void *k, const void *e)
{
	return (strcmp(k, ((const struct keywords *)e)->k_name));
}

int
lookup(char *s)
{
	/* this has to be sorted always */
	static const struct keywords keywords[] = {
		{ "action",		ACTION },
		{ "alias",		ALIAS },
		{ "any",		ANY },
		{ "auth",		AUTH },
		{ "auth-optional",     	AUTH_OPTIONAL },
		{ "backup",		BACKUP },
		{ "bounce",		BOUNCE },
		{ "ca",			CA },
		{ "cert",		CERT },
		{ "ciphers",		CIPHERS },
		{ "compression",	COMPRESSION },
		{ "dhe",		DHE },
		{ "domain",		DOMAIN },
		{ "encryption",		ENCRYPTION },
		{ "expand-only",      	EXPAND_ONLY },
		{ "filter",		FILTER },
		{ "for",		FOR },
		{ "forward-only",      	FORWARD_ONLY },
		{ "from",		FROM },
		{ "helo",		HELO },
		{ "helo-src",       	HELO_SRC },
		{ "host",		HOST },
		{ "hostname",		HOSTNAME },
		{ "hostnames",		HOSTNAMES },
		{ "include",		INCLUDE },
		{ "inet4",		INET4 },
		{ "inet6",		INET6 },
		{ "junk",		JUNK },
		{ "key",		KEY },
		{ "limit",		LIMIT },
		{ "listen",		LISTEN },
		{ "lmtp",		LMTP },
		{ "local",		LOCAL },
		{ "mail-from",		MAIL_FROM },
		{ "maildir",		MAILDIR },
		{ "mask-src",		MASK_SRC },
		{ "masquerade",		MASQUERADE },
		{ "match",		MATCH },
		{ "max-deferred",  	MAX_DEFERRED },
		{ "max-message-size",  	MAX_MESSAGE_SIZE },
		{ "mbox",		MBOX },
		{ "mda",		MDA },
		{ "mta",		MTA },
		{ "mx",			MX },
		{ "no-dsn",		NO_DSN },
		{ "no-verify",		NO_VERIFY },
		{ "on",			ON },
		{ "pki",		PKI },
		{ "port",		PORT },
		{ "queue",		QUEUE },
		{ "rcpt-to",		RCPT_TO },
		{ "received-auth",     	RECEIVEDAUTH },
		{ "recipient",		RECIPIENT },
		{ "reject",		REJECT },
		{ "relay",		RELAY },
		{ "scheduler",		SCHEDULER },
		{ "senders",   		SENDERS },
		{ "smtp",		SMTP },
		{ "smtps",		SMTPS },
		{ "socket",		SOCKET },
		{ "src",		SRC },
		{ "sub-addr-delim",	SUB_ADDR_DELIM },
		{ "table",		TABLE },
		{ "tag",		TAG },
		{ "tagged",		TAGGED },
		{ "tls",		TLS },
		{ "tls-require",       	TLS_REQUIRE },
		{ "to",			TO },
		{ "ttl",		TTL },
		{ "user",		USER },
		{ "userbase",		USERBASE },
		{ "verify",		VERIFY },
		{ "virtual",		VIRTUAL },
		{ "warn-interval",	WARN_INTERVAL },
		{ "wrapper",		WRAPPER },
	};
	const struct keywords	*p;

	p = bsearch(s, keywords, sizeof(keywords)/sizeof(keywords[0]),
	    sizeof(keywords[0]), kw_cmp);

	if (p)
		return (p->k_val);
	else
		return (STRING);
}

#define START_EXPAND	1
#define DONE_EXPAND	2

static int	expanding;

int
igetc(void)
{
	int	c;

	while (1) {
		if (file->ungetpos > 0)
			c = file->ungetbuf[--file->ungetpos];
		else
			c = getc(file->stream);

		if (c == START_EXPAND)
			expanding = 1;
		else if (c == DONE_EXPAND)
			expanding = 0;
		else
			break;
	}
	return (c);
}

int
lgetc(int quotec)
{
	int		c, next;

	if (quotec) {
		if ((c = igetc()) == EOF) {
			yyerror("reached end of file while parsing "
			    "quoted string");
			if (file == topfile || popfile() == EOF)
				return (EOF);
			return (quotec);
		}
		return (c);
	}

	while ((c = igetc()) == '\\') {
		next = igetc();
		if (next != '\n') {
			c = next;
			break;
		}
		yylval.lineno = file->lineno;
		file->lineno++;
	}

	if (c == EOF) {
		/*
		 * Fake EOL when hit EOF for the first time. This gets line
		 * count right if last line in included file is syntactically
		 * invalid and has no newline.
		 */
		if (file->eof_reached == 0) {
			file->eof_reached = 1;
			return ('\n');
		}
		while (c == EOF) {
			if (file == topfile || popfile() == EOF)
				return (EOF);
			c = igetc();
		}
	}
	return (c);
}

void
lungetc(int c)
{
	if (c == EOF)
		return;

	if (file->ungetpos >= file->ungetsize) {
		void *p = reallocarray(file->ungetbuf, file->ungetsize, 2);
		if (p == NULL)
			err(1, "%s", __func__);
		file->ungetbuf = p;
		file->ungetsize *= 2;
	}
	file->ungetbuf[file->ungetpos++] = c;
}

int
findeol(void)
{
	int	c;

	/* skip to either EOF or the first real EOL */
	while (1) {
		c = lgetc(0);
		if (c == '\n') {
			file->lineno++;
			break;
		}
		if (c == EOF)
			break;
	}
	return (ERROR);
}

int
yylex(void)
{
	unsigned char	 buf[8096];
	unsigned char	*p, *val;
	int		 quotec, next, c;
	int		 token;

top:
	p = buf;
	while ((c = lgetc(0)) == ' ' || c == '\t')
		; /* nothing */

	yylval.lineno = file->lineno;
	if (c == '#')
		while ((c = lgetc(0)) != '\n' && c != EOF)
			; /* nothing */
	if (c == '$' && !expanding) {
		while (1) {
			if ((c = lgetc(0)) == EOF)
				return (0);

			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			if (isalnum(c) || c == '_') {
				*p++ = c;
				continue;
			}
			*p = '\0';
			lungetc(c);
			break;
		}
		val = symget(buf);
		if (val == NULL) {
			yyerror("macro '%s' not defined", buf);
			return (findeol());
		}
		p = val + strlen(val) - 1;
		lungetc(DONE_EXPAND);
		while (p >= val) {
			lungetc(*p);
			p--;
		}
		lungetc(START_EXPAND);
		goto top;
	}

	switch (c) {
	case '\'':
	case '"':
		quotec = c;
		while (1) {
			if ((c = lgetc(quotec)) == EOF)
				return (0);
			if (c == '\n') {
				file->lineno++;
				continue;
			} else if (c == '\\') {
				if ((next = lgetc(quotec)) == EOF)
					return (0);
				if (next == quotec || c == ' ' || c == '\t')
					c = next;
				else if (next == '\n') {
					file->lineno++;
					continue;
				} else
					lungetc(next);
			} else if (c == quotec) {
				*p = '\0';
				break;
			} else if (c == '\0') {
				yyerror("syntax error");
				return (findeol());
			}
			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			*p++ = c;
		}
		yylval.v.string = strdup(buf);
		if (yylval.v.string == NULL)
			err(1, "%s", __func__);
		return (STRING);
	}

#define allowed_to_end_number(x) \
	(isspace(x) || x == ')' || x ==',' || x == '/' || x == '}' || x == '=')

	if (c == '-' || isdigit(c)) {
		do {
			*p++ = c;
			if ((unsigned)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && isdigit(c));
		lungetc(c);
		if (p == buf + 1 && buf[0] == '-')
			goto nodigits;
		if (c == EOF || allowed_to_end_number(c)) {
			const char *errstr = NULL;

			*p = '\0';
			yylval.v.number = strtonum(buf, LLONG_MIN,
			    LLONG_MAX, &errstr);
			if (errstr) {
				yyerror("\"%s\" invalid number: %s",
				    buf, errstr);
				return (findeol());
			}
			return (NUMBER);
		} else {
nodigits:
			while (p > buf + 1)
				lungetc(*--p);
			c = *--p;
			if (c == '-')
				return (c);
		}
	}

	if (c == '=') {
		if ((c = lgetc(0)) != EOF && c == '>')
			return (ARROW);
		lungetc(c);
		c = '=';
	}

#define allowed_in_string(x) \
	(isalnum(x) || (ispunct(x) && x != '(' && x != ')' && \
	x != '{' && x != '}' && x != '<' && x != '>' && \
	x != '!' && x != '=' && x != '#' && \
	x != ','))

	if (isalnum(c) || c == ':' || c == '_') {
		do {
			*p++ = c;
			if ((unsigned)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && (allowed_in_string(c)));
		lungetc(c);
		*p = '\0';
		if ((token = lookup(buf)) == STRING)
			if ((yylval.v.string = strdup(buf)) == NULL)
				err(1, "%s", __func__);
		return (token);
	}
	if (c == '\n') {
		yylval.lineno = file->lineno;
		file->lineno++;
	}
	if (c == EOF)
		return (0);
	return (c);
}

int
check_file_secrecy(int fd, const char *fname)
{
	struct stat	st;

	if (fstat(fd, &st)) {
		log_warn("warn: cannot stat %s", fname);
		return (-1);
	}
	if (st.st_uid != 0 && st.st_uid != getuid()) {
		log_warnx("warn: %s: owner not root or current user", fname);
		return (-1);
	}
	if (st.st_mode & (S_IWGRP | S_IXGRP | S_IRWXO)) {
		log_warnx("warn: %s: group/world readable/writeable", fname);
		return (-1);
	}
	return (0);
}

struct file *
pushfile(const char *name, int secret)
{
	struct file	*nfile;

	if ((nfile = calloc(1, sizeof(struct file))) == NULL) {
		log_warn("%s", __func__);
		return (NULL);
	}
	if ((nfile->name = strdup(name)) == NULL) {
		log_warn("%s", __func__);
		free(nfile);
		return (NULL);
	}
	if ((nfile->stream = fopen(nfile->name, "r")) == NULL) {
		log_warn("%s: %s", __func__, nfile->name);
		free(nfile->name);
		free(nfile);
		return (NULL);
	} else if (secret &&
	    check_file_secrecy(fileno(nfile->stream), nfile->name)) {
		fclose(nfile->stream);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	nfile->lineno = TAILQ_EMPTY(&files) ? 1 : 0;
	nfile->ungetsize = 16;
	nfile->ungetbuf = malloc(nfile->ungetsize);
	if (nfile->ungetbuf == NULL) {
		log_warn("%s", __func__);
		fclose(nfile->stream);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	TAILQ_INSERT_TAIL(&files, nfile, entry);
	return (nfile);
}

int
popfile(void)
{
	struct file	*prev;

	if ((prev = TAILQ_PREV(file, files, entry)) != NULL)
		prev->errors += file->errors;

	TAILQ_REMOVE(&files, file, entry);
	fclose(file->stream);
	free(file->name);
	free(file->ungetbuf);
	free(file);
	file = prev;
	return (file ? 0 : EOF);
}

int
parse_config(struct smtpd *x_conf, const char *filename, int opts)
{
	struct sym     *sym, *next;

	conf = x_conf;
	errors = 0;

	if ((file = pushfile(filename, 0)) == NULL) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}
	topfile = file;

	/*
	 * parse configuration
	 */
	setservent(1);
	yyparse();
	errors = file->errors;
	popfile();
	endservent();

	/* If the socket listener was not configured, create a default one. */
	if (!conf->sc_sock_listener) {
		memset(&listen_opts, 0, sizeof listen_opts);
		create_sock_listener(&listen_opts);
	}

	/* Free macros and check which have not been used. */
	TAILQ_FOREACH_SAFE(sym, &symhead, entry, next) {
		if ((conf->sc_opts & SMTPD_OPT_VERBOSE) && !sym->used)
			fprintf(stderr, "warning: macro '%s' not "
			    "used\n", sym->nam);
		if (!sym->persist) {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}

	if (TAILQ_EMPTY(conf->sc_rules)) {
		log_warnx("warn: no rules, nothing to do");
		errors++;
	}

	if (errors) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}

	return (0);
}

int
symset(const char *nam, const char *val, int persist)
{
	struct sym	*sym;

	TAILQ_FOREACH(sym, &symhead, entry) {
		if (strcmp(nam, sym->nam) == 0)
			break;
	}

	if (sym != NULL) {
		if (sym->persist == 1)
			return (0);
		else {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}
	if ((sym = calloc(1, sizeof(*sym))) == NULL)
		return (-1);

	sym->nam = strdup(nam);
	if (sym->nam == NULL) {
		free(sym);
		return (-1);
	}
	sym->val = strdup(val);
	if (sym->val == NULL) {
		free(sym->nam);
		free(sym);
		return (-1);
	}
	sym->used = 0;
	sym->persist = persist;
	TAILQ_INSERT_TAIL(&symhead, sym, entry);
	return (0);
}

int
cmdline_symset(char *s)
{
	char	*sym, *val;
	int	ret;

	if ((val = strrchr(s, '=')) == NULL)
		return (-1);
	sym = strndup(s, val - s);
	if (sym == NULL)
		errx(1, "%s: strndup", __func__);
	ret = symset(sym, val + 1, 1);
	free(sym);

	return (ret);
}

char *
symget(const char *nam)
{
	struct sym	*sym;

	TAILQ_FOREACH(sym, &symhead, entry) {
		if (strcmp(nam, sym->nam) == 0) {
			sym->used = 1;
			return (sym->val);
		}
	}
	return (NULL);
}

static void
create_sock_listener(struct listen_opts *lo)
{
	struct listener *l = xcalloc(1, sizeof(*l));
	lo->tag = "local";
	lo->hostname = conf->sc_hostname;
	l->ss.ss_family = AF_LOCAL;
	l->ss.ss_len = sizeof(struct sockaddr *);
	l->local = 1;
	conf->sc_sock_listener = l;
	config_listener(l, lo);
}

static void
create_if_listener(struct listen_opts *lo)
{
	uint16_t	flags;

	if (lo->port != 0 && lo->ssl == F_SSL)
		errx(1, "invalid listen option: tls/smtps on same port");

	if (lo->auth != 0 && !lo->ssl)
		errx(1, "invalid listen option: auth requires tls/smtps");

	if (lo->pki && !lo->ssl)
		errx(1, "invalid listen option: pki requires tls/smtps");

	flags = lo->flags;

	if (lo->port) {
		lo->flags = lo->ssl|lo->auth|flags;
		lo->port = htons(lo->port);
	}
	else {
		if (lo->ssl & F_SMTPS) {
			lo->port = htons(465);
			lo->flags = F_SMTPS|lo->auth|flags;
		}

		if (!lo->ssl || (lo->ssl & F_STARTTLS)) {
			lo->port = htons(25);
			lo->flags = lo->auth|flags;
			if (lo->ssl & F_STARTTLS)
				lo->flags |= F_STARTTLS;
		}
	}

	if (interface(lo))
		return;
	if (host_v4(lo))
		return;
	if (host_v6(lo))
		return;
	if (host_dns(lo))
		return;

	errx(1, "invalid virtual ip or interface: %s", lo->ifx);
}

static void
config_listener(struct listener *h,  struct listen_opts *lo)
{
	h->fd = -1;
	h->port = lo->port;
	h->flags = lo->flags;

	if (lo->hostname == NULL)
		lo->hostname = conf->sc_hostname;

	if (lo->filtername)
		(void)strlcpy(h->filter, lo->filtername, sizeof(h->filter));

	h->pki_name[0] = '\0';

	if (lo->authtable != NULL)
		(void)strlcpy(h->authtable, lo->authtable->t_name, sizeof(h->authtable));
	if (lo->pki != NULL) {
		if (!lowercase(h->pki_name, lo->pki, sizeof(h->pki_name))) {
			log_warnx("pki name too long: %s", lo->pki);
			fatalx(NULL);
		}
		if (dict_get(conf->sc_pki_dict, h->pki_name) == NULL) {
			log_warnx("pki name not found: %s", lo->pki);
			fatalx(NULL);
		}
	}

	if (lo->ca != NULL) {
		if (!lowercase(h->ca_name, lo->ca, sizeof(h->ca_name))) {
			log_warnx("ca name too long: %s", lo->ca);
			fatalx(NULL);
		}
		if (dict_get(conf->sc_ca_dict, h->ca_name) == NULL) {
			log_warnx("ca name not found: %s", lo->ca);
			fatalx(NULL);
		}
	}
	if (lo->tag != NULL)
		(void)strlcpy(h->tag, lo->tag, sizeof(h->tag));

	(void)strlcpy(h->hostname, lo->hostname, sizeof(h->hostname));
	if (lo->hostnametable)
		(void)strlcpy(h->hostnametable, lo->hostnametable->t_name, sizeof(h->hostnametable));
	if (lo->sendertable) {
		(void)strlcpy(h->sendertable, lo->sendertable->t_name, sizeof(h->sendertable));
		if (lo->options & LO_MASQUERADE)
			h->flags |= F_MASQUERADE;
	}

	if (lo->ssl & F_TLS_VERIFY)
		h->flags |= F_TLS_VERIFY;

	if (lo->ssl & F_STARTTLS_REQUIRE)
		h->flags |= F_STARTTLS_REQUIRE;
	
	if (h != conf->sc_sock_listener)
		TAILQ_INSERT_TAIL(conf->sc_listeners, h, entry);
}

static int
host_v4(struct listen_opts *lo)
{
	struct in_addr		 ina;
	struct sockaddr_in	*sain;
	struct listener		*h;

	if (lo->family != AF_UNSPEC && lo->family != AF_INET)
		return (0);

	memset(&ina, 0, sizeof(ina));
	if (inet_pton(AF_INET, lo->ifx, &ina) != 1)
		return (0);

	h = xcalloc(1, sizeof(*h));
	sain = (struct sockaddr_in *)&h->ss;
	sain->sin_len = sizeof(struct sockaddr_in);
	sain->sin_family = AF_INET;
	sain->sin_addr.s_addr = ina.s_addr;
	sain->sin_port = lo->port;

	if (sain->sin_addr.s_addr == htonl(INADDR_LOOPBACK))
		h->local = 1;
	config_listener(h,  lo);

	return (1);
}

static int
host_v6(struct listen_opts *lo)
{
	struct in6_addr		 ina6;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	if (lo->family != AF_UNSPEC && lo->family != AF_INET6)
		return (0);

	memset(&ina6, 0, sizeof(ina6));
	if (inet_pton(AF_INET6, lo->ifx, &ina6) != 1)
		return (0);

	h = xcalloc(1, sizeof(*h));
	sin6 = (struct sockaddr_in6 *)&h->ss;
	sin6->sin6_len = sizeof(struct sockaddr_in6);
	sin6->sin6_family = AF_INET6;
	sin6->sin6_port = lo->port;
	memcpy(&sin6->sin6_addr, &ina6, sizeof(ina6));

	if (IN6_IS_ADDR_LOOPBACK(&sin6->sin6_addr))
		h->local = 1;
	config_listener(h,  lo);

	return (1);
}

static int
host_dns(struct listen_opts *lo)
{
	struct addrinfo		 hints, *res0, *res;
	int			 error, cnt = 0;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	memset(&hints, 0, sizeof(hints));
	hints.ai_family = lo->family;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_flags = AI_ADDRCONFIG;
	error = getaddrinfo(lo->ifx, NULL, &hints, &res0);
	if (error == EAI_AGAIN || error == EAI_NODATA || error == EAI_NONAME)
		return (0);
	if (error) {
		log_warnx("warn: host_dns: could not parse \"%s\": %s", lo->ifx,
		    gai_strerror(error));
		return (-1);
	}

	for (res = res0; res; res = res->ai_next) {
		if (res->ai_family != AF_INET &&
		    res->ai_family != AF_INET6)
			continue;
		h = xcalloc(1, sizeof(*h));

		h->ss.ss_family = res->ai_family;
		if (res->ai_family == AF_INET) {
			sain = (struct sockaddr_in *)&h->ss;
			sain->sin_len = sizeof(struct sockaddr_in);
			sain->sin_addr.s_addr = ((struct sockaddr_in *)
			    res->ai_addr)->sin_addr.s_addr;
			sain->sin_port = lo->port;
			if (sain->sin_addr.s_addr == htonl(INADDR_LOOPBACK))
				h->local = 1;
		} else {
			sin6 = (struct sockaddr_in6 *)&h->ss;
			sin6->sin6_len = sizeof(struct sockaddr_in6);
			memcpy(&sin6->sin6_addr, &((struct sockaddr_in6 *)
			    res->ai_addr)->sin6_addr, sizeof(struct in6_addr));
			sin6->sin6_port = lo->port;
			if (IN6_IS_ADDR_LOOPBACK(&sin6->sin6_addr))
				h->local = 1;
		}

		config_listener(h, lo);

		cnt++;
	}

	freeaddrinfo(res0);
	return (cnt);
}

static int
interface(struct listen_opts *lo)
{
	struct ifaddrs *ifap, *p;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;
	int			ret = 0;

	if (getifaddrs(&ifap) == -1)
		fatal("getifaddrs");

	for (p = ifap; p != NULL; p = p->ifa_next) {
		if (p->ifa_addr == NULL)
			continue;
		if (strcmp(p->ifa_name, lo->ifx) != 0 &&
		    !is_if_in_group(p->ifa_name, lo->ifx))
			continue;
		if (lo->family != AF_UNSPEC && lo->family != p->ifa_addr->sa_family)
			continue;

		h = xcalloc(1, sizeof(*h));

		switch (p->ifa_addr->sa_family) {
		case AF_INET:
			sain = (struct sockaddr_in *)&h->ss;
			*sain = *(struct sockaddr_in *)p->ifa_addr;
			sain->sin_len = sizeof(struct sockaddr_in);
			sain->sin_port = lo->port;
			if (sain->sin_addr.s_addr == htonl(INADDR_LOOPBACK))
				h->local = 1;
			break;

		case AF_INET6:
			sin6 = (struct sockaddr_in6 *)&h->ss;
			*sin6 = *(struct sockaddr_in6 *)p->ifa_addr;
			sin6->sin6_len = sizeof(struct sockaddr_in6);
			sin6->sin6_port = lo->port;
			if (IN6_IS_ADDR_LOOPBACK(&sin6->sin6_addr))
				h->local = 1;
			break;

		default:
			free(h);
			continue;
		}

		config_listener(h, lo);
		ret = 1;
	}

	freeifaddrs(ifap);

	return ret;
}

int
delaytonum(char *str)
{
	unsigned int     factor;
	size_t           len;
	const char      *errstr = NULL;
	int              delay;

	/* we need at least 1 digit and 1 unit */
	len = strlen(str);
	if (len < 2)
		goto bad;

	switch(str[len - 1]) {

	case 's':
		factor = 1;
		break;

	case 'm':
		factor = 60;
		break;

	case 'h':
		factor = 60 * 60;
		break;

	case 'd':
		factor = 24 * 60 * 60;
		break;

	default:
		goto bad;
	}

	str[len - 1] = '\0';
	delay = strtonum(str, 1, INT_MAX / factor, &errstr);
	if (errstr)
		goto bad;

	return (delay * factor);

bad:
	return (-1);
}

int
is_if_in_group(const char *ifname, const char *groupname)
{
        unsigned int		 len;
        struct ifgroupreq        ifgr;
        struct ifg_req          *ifg;
	int			 s;
	int			 ret = 0;

	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
		err(1, "socket");

        memset(&ifgr, 0, sizeof(ifgr));
        if (strlcpy(ifgr.ifgr_name, ifname, IFNAMSIZ) >= IFNAMSIZ)
		errx(1, "interface name too large");

        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1) {
                if (errno == EINVAL || errno == ENOTTY)
			goto end;
		err(1, "SIOCGIFGROUP");
        }

        len = ifgr.ifgr_len;
        ifgr.ifgr_groups = xcalloc(len/sizeof(struct ifg_req),
		sizeof(struct ifg_req));
        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1)
                err(1, "SIOCGIFGROUP");

        ifg = ifgr.ifgr_groups;
        for (; ifg && len >= sizeof(struct ifg_req); ifg++) {
                len -= sizeof(struct ifg_req);
		if (strcmp(ifg->ifgrq_group, groupname) == 0) {
			ret = 1;
			break;
		}
        }
        free(ifgr.ifgr_groups);

end:
	close(s);
	return ret;
}

static int
config_lo_filter(struct listen_opts *lo, char *filter_name) {
	if (lo->options & LO_FILTER) {
		yyerror("filter already specified");
		return -1;
	}
	lo->options |= LO_FILTER;
	lo->filtername = filter_name;

	return 0;
}

static int
config_lo_mask_source(struct listen_opts *lo) {
	if (lo->options & LO_MASKSOURCE) {
		yyerror("mask-source already specified");
		return -1;
	}
	lo->options |= LO_MASKSOURCE;
	lo->flags |= F_MASK_SOURCE;

	return 0;
}

#line 1789 "parse.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(void)
{
    unsigned int newsize;
    long sslen;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    sslen = yyssp - yyss;
#ifdef SIZE_MAX
#define YY_SIZE_MAX SIZE_MAX
#else
#define YY_SIZE_MAX 0xffffffffU
#endif
    if (newsize && YY_SIZE_MAX / newsize < sizeof *newss)
        goto bail;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss); /* overflow check above */
    if (newss == NULL)
        goto bail;
    yyss = newss;
    yyssp = newss + sslen;
    if (newsize && YY_SIZE_MAX / newsize < sizeof *newvs)
        goto bail;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs); /* overflow check above */
    if (newvs == NULL)
        goto bail;
    yyvs = newvs;
    yyvsp = newvs + sslen;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
bail:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return -1;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif /* YYDEBUG */

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yyvsp[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 17:
#line 220 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{ file->errors++; }
break;
case 18:
#line 223 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			struct file	*nfile;

			if ((nfile = pushfile(yyvsp[0].v.string, 0)) == NULL) {
				yyerror("failed to include file %s", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);

			file = nfile;
			lungetc('\n');
		}
break;
case 19:
#line 238 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			char *s = yyvsp[-2].v.string;
			while (*s++) {
				if (isspace((unsigned char)*s)) {
					yyerror("macro name cannot contain "
					    "whitespace");
					free(yyvsp[-2].v.string);
					free(yyvsp[0].v.string);
					YYERROR;
				}
			}
			if (symset(yyvsp[-2].v.string, yyvsp[0].v.string, 0) == -1)
				fatal("cannot store variable");
			free(yyvsp[-2].v.string);
			free(yyvsp[0].v.string);
		}
break;
case 26:
#line 268 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{ yyval.v.number = 1; }
break;
case 27:
#line 269 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{ yyval.v.number = 0; }
break;
case 30:
#line 275 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			table->t_type = T_HASH;
			table_add(table, yyvsp[-2].v.string, yyvsp[0].v.string);
			free(yyvsp[-2].v.string);
			free(yyvsp[0].v.string);
		}
break;
case 33:
#line 287 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			table->t_type = T_LIST;
			table_add(table, yyvsp[0].v.string, NULL);
			free(yyvsp[0].v.string);
		}
break;
case 36:
#line 298 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{ }
break;
case 37:
#line 299 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{ }
break;
case 38:
#line 303 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	memset(conf->sc_bounce_warn, 0, sizeof conf->sc_bounce_warn);
}
break;
case 40:
#line 310 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	char buf[HOST_NAME_MAX+1];

	/* if not catchall, check that it is a valid domain */
	if (strcmp(yyvsp[0].v.string, "*") != 0) {
		if (!res_hnok(yyvsp[0].v.string)) {
			yyerror("not a valid domain name: %s", yyvsp[0].v.string);
			free(yyvsp[0].v.string);
			YYERROR;
		}
	}
	xlowercase(buf, yyvsp[0].v.string, sizeof(buf));
	free(yyvsp[0].v.string);
	sca = dict_get(conf->sc_ca_dict, buf);
	if (sca == NULL) {
		sca = xcalloc(1, sizeof *sca);
		(void)strlcpy(sca->ca_name, buf, sizeof(sca->ca_name));
		dict_set(conf->sc_ca_dict, sca->ca_name, sca);
	}
}
break;
case 42:
#line 334 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	sca->ca_cert_file = yyvsp[0].v.string;
}
break;
case 45:
#line 346 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (dict_get(conf->sc_mda_wrappers, yyvsp[-1].v.string)) {
		yyerror("mda wrapper already declared with that name: %s", yyvsp[-1].v.string);
		YYERROR;
	}
	dict_set(conf->sc_mda_wrappers, yyvsp[-1].v.string, yyvsp[0].v.string);
}
break;
case 46:
#line 357 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	conf->sc_mta_max_deferred = yyvsp[0].v.number;
}
break;
case 47:
#line 360 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct mta_limits	*d;

	limits = dict_get(conf->sc_limits_dict, yyvsp[0].v.string);
	if (limits == NULL) {
		limits = xcalloc(1, sizeof(*limits));
		dict_xset(conf->sc_limits_dict, yyvsp[0].v.string, limits);
		d = dict_xget(conf->sc_limits_dict, "default");
		memmove(limits, d, sizeof(*limits));
	}
	free(yyvsp[0].v.string);
}
break;
case 49:
#line 372 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	limits = dict_get(conf->sc_limits_dict, "default");
}
break;
case 51:
#line 379 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	char buf[HOST_NAME_MAX+1];

	/* if not catchall, check that it is a valid domain */
	if (strcmp(yyvsp[0].v.string, "*") != 0) {
		if (!res_hnok(yyvsp[0].v.string)) {
			yyerror("not a valid domain name: %s", yyvsp[0].v.string);
			free(yyvsp[0].v.string);
			YYERROR;
		}
	}
	xlowercase(buf, yyvsp[0].v.string, sizeof(buf));
	free(yyvsp[0].v.string);
	pki = dict_get(conf->sc_pki_dict, buf);
	if (pki == NULL) {
		pki = xcalloc(1, sizeof *pki);
		(void)strlcpy(pki->pki_name, buf, sizeof(pki->pki_name));
		dict_set(conf->sc_pki_dict, pki->pki_name, pki);
	}
}
break;
case 53:
#line 402 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	pki->pki_cert_file = yyvsp[0].v.string;
}
break;
case 54:
#line 405 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	pki->pki_key_file = yyvsp[0].v.string;
}
break;
case 55:
#line 408 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (strcasecmp(yyvsp[0].v.string, "none") == 0)
		pki->pki_dhe = 0;
	else if (strcasecmp(yyvsp[0].v.string, "auto") == 0)
		pki->pki_dhe = 1;
	else if (strcasecmp(yyvsp[0].v.string, "legacy") == 0)
		pki->pki_dhe = 2;
	else {
		yyerror("invalid DHE keyword: %s", yyvsp[0].v.string);
		free(yyvsp[0].v.string);
		YYERROR;
	}
	free(yyvsp[0].v.string);
}
break;
case 58:
#line 432 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	conf->sc_queue_flags |= QUEUE_COMPRESSION;
}
break;
case 59:
#line 435 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	conf->sc_queue_flags |= QUEUE_ENCRYPTION;
}
break;
case 60:
#line 438 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (strcasecmp(yyvsp[0].v.string, "stdin") == 0 || strcasecmp(yyvsp[0].v.string, "-") == 0) {
		conf->sc_queue_key = "stdin";
		free(yyvsp[0].v.string);
	}
	else
		conf->sc_queue_key = yyvsp[0].v.string;
	conf->sc_queue_flags |= QUEUE_ENCRYPTION;
}
break;
case 61:
#line 447 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	conf->sc_ttl = delaytonum(yyvsp[0].v.string);
	if (conf->sc_ttl == -1) {
		yyerror("invalid ttl delay: %s", yyvsp[0].v.string);
		free(yyvsp[0].v.string);
		YYERROR;
	}
	free(yyvsp[0].v.string);
}
break;
case 64:
#line 466 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	conf->sc_tls_ciphers = yyvsp[0].v.string;
}
break;
case 65:
#line 469 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	conf->sc_maxsize = yyvsp[0].v.number;
}
break;
case 66:
#line 472 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (strlen(yyvsp[0].v.string) != 1) {
		yyerror("subaddressing-delimiter must be one character");
		free(yyvsp[0].v.string);
		YYERROR;
	}
	if (isspace((int)*yyvsp[0].v.string) ||  !isprint((int)*yyvsp[0].v.string) || *yyvsp[0].v.string== '@') {
		yyerror("sub-addr-delim uses invalid character");
		free(yyvsp[0].v.string);
		YYERROR;
	}
	conf->sc_subaddressing_delim = yyvsp[0].v.string;
}
break;
case 67:
#line 489 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (dispatcher->u.local.requires_root) {
		yyerror("user may not be specified for this dispatcher");
		YYERROR;
	}

	if (dispatcher->u.local.forward_only) {
		yyerror("user may not be specified for forward-only");
		YYERROR;
	}

	if (dispatcher->u.local.expand_only) {
		yyerror("user may not be specified for expand-only");
		YYERROR;
	}

	if (dispatcher->u.local.user) {
		yyerror("user already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.local.user = yyvsp[0].v.string;
}
break;
case 68:
#line 512 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = yyvsp[0].v.table;

	if (dispatcher->u.local.table_alias) {
		yyerror("alias mapping already specified for this dispatcher");
		YYERROR;
	}

	if (dispatcher->u.local.table_virtual) {
		yyerror("virtual mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
		yyerror("table \"%s\" may not be used for alias lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.local.table_alias = strdup(t->t_name);
}
break;
case 69:
#line 533 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = yyvsp[0].v.table;

	if (dispatcher->u.local.table_virtual) {
		yyerror("virtual mapping already specified for this dispatcher");
		YYERROR;
	}

	if (dispatcher->u.local.table_alias) {
		yyerror("alias mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
		yyerror("table \"%s\" may not be used for virtual lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.local.table_virtual = strdup(t->t_name);
}
break;
case 70:
#line 554 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = yyvsp[0].v.table;

	if (dispatcher->u.local.table_userbase) {
		yyerror("userbase mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_USERINFO)) {
		yyerror("table \"%s\" may not be used for userbase lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.local.table_userbase = strdup(t->t_name);
}
break;
case 71:
#line 570 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (! dict_get(conf->sc_mda_wrappers, yyvsp[0].v.string)) {
		yyerror("no mda wrapper with that name: %s", yyvsp[0].v.string);
		YYERROR;
	}
	dispatcher->u.local.mda_wrapper = yyvsp[0].v.string;
}
break;
case 74:
#line 585 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	dispatcher->u.local.requires_root = 1;
	dispatcher->u.local.user = xstrdup("root");
	asprintf(&dispatcher->u.local.command, "/usr/libexec/mail.local -f %%{mbox.from} %%{user.username}");
}
break;
case 76:
#line 590 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	asprintf(&dispatcher->u.local.command, "/usr/libexec/mail.maildir");
}
break;
case 78:
#line 593 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	asprintf(&dispatcher->u.local.command, "/usr/libexec/mail.maildir -j");
}
break;
case 80:
#line 596 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (strncmp(yyvsp[0].v.string, "~/", 2) == 0)
		asprintf(&dispatcher->u.local.command,
		    "/usr/libexec/mail.maildir \"%%{user.directory}/%s\"", yyvsp[0].v.string+2);
	else
		asprintf(&dispatcher->u.local.command,
		    "/usr/libexec/mail.maildir \"%s\"", yyvsp[0].v.string);
}
break;
case 82:
#line 604 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (strncmp(yyvsp[-1].v.string, "~/", 2) == 0)
		asprintf(&dispatcher->u.local.command,
		    "/usr/libexec/mail.maildir -j \"%%{user.directory}/%s\"", yyvsp[-1].v.string+2);
	else
		asprintf(&dispatcher->u.local.command,
		    "/usr/libexec/mail.maildir -j \"%s\"", yyvsp[-1].v.string);
}
break;
case 84:
#line 612 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	asprintf(&dispatcher->u.local.command,
	    "/usr/libexec/mail.lmtp -f %%{mbox.from} -d %s %%{user.username}", yyvsp[0].v.string);
}
break;
case 86:
#line 616 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	asprintf(&dispatcher->u.local.command,
	    "/usr/libexec/mail.lmtp -f %%{mbox.from} -d %s %%{dest}", yyvsp[-1].v.string);
}
break;
case 88:
#line 620 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	asprintf(&dispatcher->u.local.command,
	    "/usr/libexec/mail.mda \"%s\"", yyvsp[0].v.string);
}
break;
case 90:
#line 624 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	dispatcher->u.local.forward_only = 1;
}
break;
case 92:
#line 627 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	dispatcher->u.local.expand_only = 1;
}
break;
case 94:
#line 634 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (dispatcher->u.remote.helo) {
		yyerror("helo already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.helo = yyvsp[0].v.string;
}
break;
case 95:
#line 642 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = yyvsp[0].v.table;

	if (dispatcher->u.remote.helo_source) {
		yyerror("helo-source mapping already specified for this dispatcher");
		YYERROR;
	}
	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
		yyerror("table \"%s\" may not be used for helo-source lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.helo_source = strdup(t->t_name);
}
break;
case 96:
#line 657 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (dispatcher->u.remote.pki) {
		yyerror("pki already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.pki = yyvsp[0].v.string;
}
break;
case 97:
#line 665 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (dispatcher->u.remote.ca) {
		yyerror("ca already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.ca = yyvsp[0].v.string;
}
break;
case 98:
#line 673 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = yyvsp[0].v.table;

	if (dispatcher->u.remote.source) {
		yyerror("source mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_SOURCE)) {
		yyerror("table \"%s\" may not be used for source lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.source = strdup(t->t_name);
}
break;
case 99:
#line 689 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (dispatcher->u.remote.mail_from) {
		yyerror("mail-from already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.mail_from = yyvsp[0].v.string;
}
break;
case 100:
#line 697 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (dispatcher->u.remote.backup) {
		yyerror("backup already specified for this dispatcher");
		YYERROR;
	}
	if (dispatcher->u.remote.smarthost) {
		yyerror("backup and host are mutually exclusive");
		YYERROR;
	}

	dispatcher->u.remote.backup = 1;
	dispatcher->u.remote.backupmx = yyvsp[0].v.string;
}
break;
case 101:
#line 710 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (dispatcher->u.remote.backup) {
		yyerror("backup already specified for this dispatcher");
		YYERROR;
	}
	if (dispatcher->u.remote.smarthost) {
		yyerror("backup and host are mutually exclusive");
		YYERROR;
	}

	dispatcher->u.remote.backup = 1;
}
break;
case 102:
#line 722 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = yyvsp[0].v.table;

	if (dispatcher->u.remote.smarthost) {
		yyerror("host mapping already specified for this dispatcher");
		YYERROR;
	}
	if (dispatcher->u.remote.backup) {
		yyerror("backup and host are mutually exclusive");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_RELAYHOST)) {
		yyerror("table \"%s\" may not be used for host lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.smarthost = strdup(t->t_name);
}
break;
case 103:
#line 742 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (dispatcher->u.remote.tls_required == 1) {
		yyerror("tls already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.tls_required = 1;
}
break;
case 104:
#line 750 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (dispatcher->u.remote.tls_required == 1) {
		yyerror("tls already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.tls_required = 1;
	dispatcher->u.remote.tls_noverify = 1;
}
break;
case 105:
#line 759 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = yyvsp[0].v.table;

	if (dispatcher->u.remote.smarthost == NULL) {
		yyerror("auth may not be specified without host on a dispatcher");
		YYERROR;
	}

	if (dispatcher->u.remote.auth) {
		yyerror("auth mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_CREDENTIALS)) {
		yyerror("table \"%s\" may not be used for auth lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.auth = strdup(t->t_name);
}
break;
case 109:
#line 792 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	dispatcher->type = DISPATCHER_LOCAL;
}
break;
case 110:
#line 795 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	dispatcher->type = DISPATCHER_REMOTE;
}
break;
case 111:
#line 801 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (dispatcher->ttl) {
		yyerror("ttl already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->ttl = delaytonum(yyvsp[0].v.string);
	if (dispatcher->ttl == -1) {
		yyerror("ttl delay \"%s\" is invalid", yyvsp[0].v.string);
		free(yyvsp[0].v.string);
		YYERROR;
	}
	free(yyvsp[0].v.string);
}
break;
case 114:
#line 823 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (dict_get(conf->sc_dispatchers, yyvsp[0].v.string)) {
		yyerror("dispatcher already declared with that name: %s", yyvsp[0].v.string);
		YYERROR;
	}
	dispatcher = xcalloc(1, sizeof *dispatcher);
}
break;
case 115:
#line 829 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (dispatcher->type == DISPATCHER_LOCAL)
		if (dispatcher->u.local.table_userbase == NULL)
			dispatcher->u.local.table_userbase = "<getpwnam>";
	dict_set(conf->sc_dispatchers, yyvsp[-3].v.string, dispatcher);
	dispatcher = NULL;
}
break;
case 116:
#line 839 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = yyvsp[0].v.table;

	if (rule->flag_tag) {
		yyerror("tag already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_STRING)) {
		yyerror("table \"%s\" may not be used for tag lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_tag = yyvsp[-2].v.number ? -1 : 1;
	rule->table_tag = strdup(t->t_name);
}
break;
case 117:
#line 856 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = yyvsp[0].v.table;

	if (rule->flag_smtp_helo) {
		yyerror("mail-helo already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
		yyerror("table \"%s\" may not be used for helo lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_helo = yyvsp[-2].v.number ? -1 : 1;
	rule->table_smtp_helo = strdup(t->t_name);
}
break;
case 118:
#line 873 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (rule->flag_smtp_starttls) {
		yyerror("tls already specified for this rule");
		YYERROR;
	}
	rule->flag_smtp_starttls = yyvsp[-1].v.number ? -1 : 1;
}
break;
case 119:
#line 880 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (rule->flag_smtp_auth) {
		yyerror("auth already specified for this rule");
		YYERROR;
	}
	rule->flag_smtp_auth = yyvsp[-1].v.number ? -1 : 1;
}
break;
case 120:
#line 887 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = yyvsp[0].v.table;

	if (rule->flag_smtp_auth) {
		yyerror("auth already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_CREDENTIALS)) {
		yyerror("table \"%s\" may not be used for auth lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_auth = yyvsp[-2].v.number ? -1 : 1;
	rule->table_smtp_auth = strdup(t->t_name);
}
break;
case 121:
#line 904 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = yyvsp[0].v.table;

	if (rule->flag_smtp_mail_from) {
		yyerror("mail-from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
		yyerror("table \"%s\" may not be used for mail-from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_mail_from = yyvsp[-2].v.number ? -1 : 1;
	rule->table_smtp_mail_from = strdup(t->t_name);
}
break;
case 122:
#line 921 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = yyvsp[0].v.table;

	if (rule->flag_smtp_rcpt_to) {
		yyerror("rcpt-to already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
		yyerror("table \"%s\" may not be used for rcpt-to lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_rcpt_to = yyvsp[-2].v.number ? -1 : 1;
	rule->table_smtp_rcpt_to = strdup(t->t_name);
}
break;
case 123:
#line 939 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}
	rule->flag_from = yyvsp[-2].v.number ? -1 : 1;
	rule->flag_from_socket = 1;
}
break;
case 124:
#line 947 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table	*t = table_find(conf, "<localhost>", NULL);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}
	rule->flag_from = yyvsp[-2].v.number ? -1 : 1;
	rule->table_from = strdup(t->t_name);
}
break;
case 125:
#line 957 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table	*t = table_find(conf, "<anyhost>", NULL);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}
	rule->flag_from = yyvsp[-2].v.number ? -1 : 1;
	rule->table_from = strdup(t->t_name);
}
break;
case 126:
#line 967 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = yyvsp[0].v.table;

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_NETADDR)) {
		yyerror("table \"%s\" may not be used for from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_from = yyvsp[-3].v.number ? -1 : 1;
	rule->table_from = strdup(t->t_name);
}
break;
case 127:
#line 985 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = table_find(conf, "<localnames>", NULL);

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}
	rule->flag_for = yyvsp[-2].v.number ? -1 : 1;
	rule->table_for = strdup(t->t_name);
}
break;
case 128:
#line 995 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = table_find(conf, "<anydestination>", NULL);

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}
	rule->flag_for = yyvsp[-2].v.number ? -1 : 1;
	rule->table_for = strdup(t->t_name);
}
break;
case 129:
#line 1005 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	struct table   *t = yyvsp[0].v.table;

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
		yyerror("table \"%s\" may not be used for 'for' lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_for = yyvsp[-3].v.number ? -1 : 1;
	rule->table_for = strdup(t->t_name);
}
break;
case 132:
#line 1030 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (dict_get(conf->sc_dispatchers, yyvsp[0].v.string) == NULL) {
		yyerror("no such dispatcher: %s", yyvsp[0].v.string);
		YYERROR;
	}
	rule->dispatcher = yyvsp[0].v.string;
}
break;
case 133:
#line 1040 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	rule->reject = 1;
}
break;
case 135:
#line 1047 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	rule = xcalloc(1, sizeof *rule);
}
break;
case 136:
#line 1049 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
	if (!rule->flag_from) {
		rule->table_from = strdup("<localhost>");
		rule->flag_from = 1;
	}
	if (!rule->flag_for) {
		rule->table_for = strdup("<localnames>");
		rule->flag_for = 1;
	}
	TAILQ_INSERT_TAIL(conf->sc_rules, rule, r_entry);
	rule = NULL;
}
break;
case 137:
#line 1063 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (yyvsp[0].v.number < 0) {
				yyerror("invalid size: %" PRId64, yyvsp[0].v.number);
				YYERROR;
			}
			yyval.v.number = yyvsp[0].v.number;
		}
break;
case 138:
#line 1070 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			long long result;

			if (scan_scaled(yyvsp[0].v.string, &result) == -1 || result < 0) {
				yyerror("invalid size: %s", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);
			yyval.v.number = result;
		}
break;
case 139:
#line 1083 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			time_t	d;
			int	i;

			d = delaytonum(yyvsp[0].v.string);
			if (d < 0) {
				yyerror("invalid bounce delay: %s", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);
			for (i = 0; i < MAX_BOUNCE_WARN; i++) {
				if (conf->sc_bounce_warn[i] != 0)
					continue;
				conf->sc_bounce_warn[i] = d;
				break;
			}
		}
break;
case 142:
#line 1107 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (!strcmp(yyvsp[-1].v.string, "max-session")) {
				conf->sc_mda_max_session = yyvsp[0].v.number;
			}
			else if (!strcmp(yyvsp[-1].v.string, "max-session-per-user")) {
				conf->sc_mda_max_user_session = yyvsp[0].v.number;
			}
			else if (!strcmp(yyvsp[-1].v.string, "task-lowat")) {
				conf->sc_mda_task_lowat = yyvsp[0].v.number;
			}
			else if (!strcmp(yyvsp[-1].v.string, "task-hiwat")) {
				conf->sc_mda_task_hiwat = yyvsp[0].v.number;
			}
			else if (!strcmp(yyvsp[-1].v.string, "task-release")) {
				conf->sc_mda_task_release = yyvsp[0].v.number;
			}
			else {
				yyerror("invalid scheduler limit keyword: %s", yyvsp[-1].v.string);
				free(yyvsp[-1].v.string);
				YYERROR;
			}
			free(yyvsp[-1].v.string);
		}
break;
case 145:
#line 1136 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (!strcmp(yyvsp[-1].v.string, "max-rcpt")) {
				conf->sc_session_max_rcpt = yyvsp[0].v.number;
			}
			else if (!strcmp(yyvsp[-1].v.string, "max-mails")) {
				conf->sc_session_max_mails = yyvsp[0].v.number;
			}
			else {
				yyerror("invalid session limit keyword: %s", yyvsp[-1].v.string);
				free(yyvsp[-1].v.string);
				YYERROR;
			}
			free(yyvsp[-1].v.string);
		}
break;
case 148:
#line 1156 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			limits->family = AF_INET;
		}
break;
case 149:
#line 1159 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			limits->family = AF_INET6;
		}
break;
case 150:
#line 1162 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (!limit_mta_set(limits, yyvsp[-1].v.string, yyvsp[0].v.number)) {
				yyerror("invalid mta limit keyword: %s", yyvsp[-1].v.string);
				free(yyvsp[-1].v.string);
				YYERROR;
			}
			free(yyvsp[-1].v.string);
		}
break;
case 153:
#line 1176 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (!strcmp(yyvsp[-1].v.string, "max-inflight")) {
				conf->sc_scheduler_max_inflight = yyvsp[0].v.number;
			}
			else if (!strcmp(yyvsp[-1].v.string, "max-evp-batch-size")) {
				conf->sc_scheduler_max_evp_batch_size = yyvsp[0].v.number;
			}
			else if (!strcmp(yyvsp[-1].v.string, "max-msg-batch-size")) {
				conf->sc_scheduler_max_msg_batch_size = yyvsp[0].v.number;
			}
			else if (!strcmp(yyvsp[-1].v.string, "max-schedule")) {
				conf->sc_scheduler_max_schedule = yyvsp[0].v.number;
			}
			else {
				yyerror("invalid scheduler limit keyword: %s", yyvsp[-1].v.string);
				free(yyvsp[-1].v.string);
				YYERROR;
			}
			free(yyvsp[-1].v.string);
		}
break;
case 156:
#line 1203 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (config_lo_filter(&listen_opts, yyvsp[0].v.string)) {
				YYERROR;
			}
		}
break;
case 157:
#line 1208 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (config_lo_mask_source(&listen_opts)) {
				YYERROR;
			}
		}
break;
case 158:
#line 1215 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_FAMILY) {
				yyerror("address family already specified");
				YYERROR;
			}
			listen_opts.options |= LO_FAMILY;
			listen_opts.family = AF_INET;
		}
break;
case 159:
#line 1223 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_FAMILY) {
				yyerror("address family already specified");
				YYERROR;
			}
			listen_opts.options |= LO_FAMILY;
			listen_opts.family = AF_INET6;
		}
break;
case 160:
#line 1231 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			struct servent	*servent;

			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PORT;

			servent = getservbyname(yyvsp[0].v.string, "tcp");
			if (servent == NULL) {
				yyerror("invalid port: %s", yyvsp[0].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			free(yyvsp[0].v.string);
			listen_opts.port = ntohs(servent->s_port);
		}
break;
case 161:
#line 1249 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PORT;

			if (yyvsp[0].v.number <= 0 || yyvsp[0].v.number > (int)USHRT_MAX) {
				yyerror("invalid port: %" PRId64, yyvsp[0].v.number);
				YYERROR;
			}
			listen_opts.port = yyvsp[0].v.number;
		}
break;
case 162:
#line 1262 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (config_lo_filter(&listen_opts, yyvsp[0].v.string)) {
				YYERROR;
			}
		}
break;
case 163:
#line 1267 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SMTPS;
		}
break;
case 164:
#line 1275 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SMTPS|F_TLS_VERIFY;
		}
break;
case 165:
#line 1283 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS;
		}
break;
case 166:
#line 1291 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE;
		}
break;
case 167:
#line 1299 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE|F_TLS_VERIFY;
		}
break;
case 168:
#line 1307 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_PKI) {
				yyerror("pki already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PKI;
			listen_opts.pki = yyvsp[0].v.string;
		}
break;
case 169:
#line 1315 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_CA) {
				yyerror("ca already specified");
				YYERROR;
			}
			listen_opts.options |= LO_CA;
			listen_opts.ca = yyvsp[0].v.string;
		}
break;
case 170:
#line 1323 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.auth = F_AUTH|F_AUTH_REQUIRE;
		}
break;
case 171:
#line 1331 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.auth = F_AUTH;
		}
break;
case 172:
#line 1339 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.authtable = yyvsp[0].v.table;
			listen_opts.auth = F_AUTH|F_AUTH_REQUIRE;
		}
break;
case 173:
#line 1348 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.authtable = yyvsp[0].v.table;
			listen_opts.auth = F_AUTH;
		}
break;
case 174:
#line 1357 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_TAG) {
				yyerror("tag already specified");
				YYERROR;
			}
			listen_opts.options |= LO_TAG;

			if (strlen(yyvsp[0].v.string) >= SMTPD_TAG_SIZE) {
       				yyerror("tag name too long");
				free(yyvsp[0].v.string);
				YYERROR;
			}
			listen_opts.tag = yyvsp[0].v.string;
		}
break;
case 175:
#line 1371 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_HOSTNAME) {
				yyerror("hostname already specified");
				YYERROR;
			}
			listen_opts.options |= LO_HOSTNAME;

			listen_opts.hostname = yyvsp[0].v.string;
		}
break;
case 176:
#line 1380 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			struct table	*t = yyvsp[0].v.table;

			if (listen_opts.options & LO_HOSTNAMES) {
				yyerror("hostnames already specified");
				YYERROR;
			}
			listen_opts.options |= LO_HOSTNAMES;

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
				yyerror("invalid use of table \"%s\" as "
				    "HOSTNAMES parameter", t->t_name);
				YYERROR;
			}
			listen_opts.hostnametable = t;
		}
break;
case 177:
#line 1396 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (config_lo_mask_source(&listen_opts)) {
				YYERROR;
			}
		}
break;
case 178:
#line 1401 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_RECEIVEDAUTH) {
				yyerror("received-auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_RECEIVEDAUTH;
			listen_opts.flags |= F_RECEIVEDAUTH;
		}
break;
case 179:
#line 1409 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (listen_opts.options & LO_NODSN) {
				yyerror("no-dsn already specified");
				YYERROR;
			}
			listen_opts.options |= LO_NODSN;
			listen_opts.flags &= ~F_EXT_DSN;
		}
break;
case 180:
#line 1417 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			struct table	*t = yyvsp[0].v.table;

			if (listen_opts.options & LO_SENDERS) {
				yyerror("senders already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SENDERS;

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_MAILADDRMAP)) {
				yyerror("invalid use of table \"%s\" as "
				    "SENDERS parameter", t->t_name);
				YYERROR;
			}
			listen_opts.sendertable = t;
		}
break;
case 181:
#line 1433 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			struct table	*t = yyvsp[-1].v.table;

			if (listen_opts.options & LO_SENDERS) {
				yyerror("senders already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SENDERS|LO_MASQUERADE;

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_MAILADDRMAP)) {
				yyerror("invalid use of table \"%s\" as "
				    "SENDERS parameter", t->t_name);
				YYERROR;
			}
			listen_opts.sendertable = t;
		}
break;
case 184:
#line 1455 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			if (conf->sc_sock_listener) {
				yyerror("socket listener already configured");
				YYERROR;
			}
			create_sock_listener(&listen_opts);
		}
break;
case 185:
#line 1464 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			listen_opts.ifx = yyvsp[-1].v.string;
			create_if_listener(&listen_opts);
		}
break;
case 190:
#line 1479 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			memset(&listen_opts, 0, sizeof listen_opts);
			listen_opts.family = AF_UNSPEC;
			listen_opts.flags |= F_EXT_DSN;
		}
break;
case 192:
#line 1486 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			char *p, *backend, *config;

			p = yyvsp[0].v.string;
			if (*p == '/') {
				backend = "static";
				config = yyvsp[0].v.string;
			}
			else {
				backend = yyvsp[0].v.string;
				config = NULL;
				for (p = yyvsp[0].v.string; *p && *p != ':'; p++)
					;
				if (*p == ':') {
					*p = '\0';
					backend = yyvsp[0].v.string;
					config  = p+1;
				}
			}
			if (config != NULL && *config != '/') {
				yyerror("invalid backend parameter for table: %s",
				    yyvsp[-1].v.string);
				free(yyvsp[-1].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			table = table_create(conf, backend, yyvsp[-1].v.string, NULL, config);
			if (!table_config(table)) {
				yyerror("invalid configuration file %s for table %s",
				    config, table->t_name);
				free(yyvsp[-1].v.string);
				free(yyvsp[0].v.string);
				YYERROR;
			}
			table = NULL;
			free(yyvsp[-1].v.string);
			free(yyvsp[0].v.string);
		}
break;
case 193:
#line 1524 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			table = table_create(conf, "static", yyvsp[0].v.string, NULL, NULL);
			free(yyvsp[0].v.string);
		}
break;
case 194:
#line 1527 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			table = NULL;
		}
break;
case 195:
#line 1532 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			struct table	*t;

			t = table_create(conf, "static", NULL, NULL, NULL);
			t->t_type = T_LIST;
			table_add(t, yyvsp[0].v.string, NULL);
			free(yyvsp[0].v.string);
			yyval.v.table = t;
		}
break;
case 196:
#line 1541 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			table = table_create(conf, "static", NULL, NULL, NULL);
		}
break;
case 197:
#line 1543 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			yyval.v.table = table;
			table = NULL;
		}
break;
case 198:
#line 1549 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{
			struct table	*t;

			if ((t = table_find(conf, yyvsp[-1].v.string, NULL)) == NULL) {
				yyerror("no such table: %s", yyvsp[-1].v.string);
				free(yyvsp[-1].v.string);
				YYERROR;
			}
			free(yyvsp[-1].v.string);
			yyval.v.table = t;
		}
break;
case 199:
#line 1562 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{ yyval.v.table = yyvsp[0].v.table; }
break;
case 200:
#line 1563 "/home/gilles/wip/OpenSMTPD/smtpd/smtpd/../parse.y"
{ yyval.v.table = yyvsp[0].v.table; }
break;
#line 3494 "parse.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return (1);
yyaccept:
    if (yyss)
            free(yyss);
    if (yyvs)
            free(yyvs);
    yyss = yyssp = NULL;
    yyvs = yyvsp = NULL;
    yystacksize = 0;
    return (0);
}
